#include <stdlib.h>
#include <stdio.h>

#define N 50001
#define MaxD 10
#define Pmaf 20

int Maf[N+1];
int deg[N+1];

int main(void)
{
	int nmaf=0;
	for (int i=1; i<=N; i++)
		nmaf += Maf[i] = (random() % 100 < Pmaf);
	printf("%d %d\n", N, nmaf);
	for (int i=2; i<=N; i++) {
		int j;
		do { j = random() % (i-1) + 1; } while (deg[j] >= MaxD);
		printf("%d %d\n", i, j);
		deg[i]++;
		deg[j]++;
	}
	for (int i=1; i<=N; i++)
		if (Maf[i])
			printf("%d\n", i);
	int md=0;
	for (int i=1; i<=N; i++)
		if (deg[i] > md)
			md = deg[i];
	fprintf(stderr, "maxd=%d\n", md);
	return 0;
}
